﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Piston
{
 public partial class Page : UserControl
 {
  public Page()
  {
   InitializeComponent();
  }
  System.Windows.Threading.DispatcherTimer timer;
  double angle;
  const double R = 50;
  const double L = 150;
  void bAction_MouseLeftButtonDown(object sender, MouseEventArgs e)
  {
   switch (bAction.Text)
   {
    case "Action": bAction.Text = "Stop"; timer.Start(); break;
    case "Stop": bAction.Text = "Action"; timer.Stop(); break;
   }
  }

  private void LayoutRoot_Loaded(object sender, RoutedEventArgs e)
  {
   timer = new System.Windows.Threading.DispatcherTimer();
   timer.Interval = new TimeSpan(0, 0, 0, 0, 40);  // toutes les 40 millisecondes
   timer.Tick += new EventHandler(timer_Tick);
  }

  void timer_Tick(object sender, EventArgs e)
  {
   angle = (angle + 13) % 360;
   rotP1.Angle = angle;
   double H;

   double angleRad = angle * (3.14 / 180);

   double X = R + R * Math.Cos(angleRad);
   double Y = R + R * Math.Sin(angleRad);
   P2.X1 = X; P2.Y1 = Y;

   double l;
   l = 90 - angle;

   double lRad = l * 3.14 / 180;
   double rRad = Math.Asin((R / L) * Math.Sin(lRad));
   double hRad = 3.14 - lRad - rRad;
   H = L * Math.Sin(hRad) / Math.Sin(lRad);
   P2.X2 = R;
   if (Double.IsInfinity(H)) H = L;
   P2.Y2 = R + H;

   P3.SetValue(Canvas.TopProperty, R + H);
  }
 }
}
